import numpy as np
import scipy.io as si
import matplotlib.pyplot as plt
import matplotlib


font = {'family' : 'serif',
		'serif'  : 'Times New Roman',
        'weight' : 'normal',
        'size'   : 18}
matplotlib.rc('font', **font)  # pass in the font dict as kwargs
# Plot Data
Base=si.loadmat('Corner_Base.mat')
Y=Base.items()[1][1]
Xe=np.linspace(1,150,600)
Y=np.log(np.abs(Y))
fig, ax1 = plt.subplots(figsize=(18,8))
lns1=ax1.plot(Xe, Y, '--',label='Bare Plate')

Free=si.loadmat('Corner_Two.mat')
Y=Free.items()[1][1]
Y=np.log(np.abs(Y))
lns2=ax1.plot(Xe, Y, '-',label='Free Damping Layer Plate')

Con=si.loadmat('Corner_Full.mat')
Y=Con.items()[5][1]
Y=np.log(np.abs(Y))
lns3=ax1.plot(Xe, Y, '-',label='Constrained Damping Layer Plate')

ax1.set_xlim([0,150])
ax1.set_xlabel('Frequency(Hz)')
# Make the y-axis label and tick labels match the line color.
ax1.set_ylabel('Log(Displacement Frequency Response)')
lns = lns1+lns2+lns3
labs = [l.get_label() for l in lns]
ax1.legend(lns, labs, loc=3,ncol=1,fontsize=16)	

plt.show()