import numpy as np
import scipy.io as si
import matplotlib.pyplot as plt
import matplotlib


font = {'family' : 'serif',
		'serif'  : 'Times New Roman',
        'weight' : 'normal',
        'size'   : 18}
matplotlib.rc('font', **font)  # pass in the font dict as kwargs
# Plot Data

Xe=np.linspace(1,150,600)
fig, ax1 = plt.subplots(figsize=(18,8))

Base=si.loadmat('Corner_Base.mat')
Y=Base.items()[1][1]
Y=np.log(np.abs(Y))
lns1=ax1.plot(Xe, Y, '--',label='Bare Plate')

Free=si.loadmat('Corner_Two.mat')
Y=Free.items()[1][1]
Y=np.log(np.abs(Y))
lns2=ax1.plot(Xe, Y, '-',label='hc=0mm(Free Damping Layer Plate)')

Free=si.loadmat('Corner_Full_hc=0.084.mat')
Y=Free.items()[5][1]
Y=np.log(np.abs(Y))
lns3=ax1.plot(Xe, Y, '-',label='hc=0.084mm')

Con=si.loadmat('Corner_Full_hc=0.254.mat')
Y=Con.items()[5][1]
Y=np.log(np.abs(Y))
lns4=ax1.plot(Xe, Y, '-',label='hc=0.254mm')

Con=si.loadmat('Corner_Full_hc=0.508.mat')
Y=Con.items()[5][1]
Y=np.log(np.abs(Y))
lns5=ax1.plot(Xe, Y, '-',label='hc=0.508mm')

Free=si.loadmat('Corner_Full.mat')
Y=Free.items()[5][1]
Y=np.log(np.abs(Y))
lns6=ax1.plot(Xe, Y, '-',label='hc=0.762mm')

ax1.set_xlim([0,150])
ax1.set_xlabel('Frequency(Hz)')
# Make the y-axis label and tick labels match the line color.
ax1.set_ylabel('Log(Displacement Frequency Response)')
lns = lns1+lns2+lns3+lns4+lns5+lns6
labs = [l.get_label() for l in lns]
ax1.legend(lns, labs, loc=3,ncol=3,fontsize=16)	

plt.show()