import numpy as np
import scipy.io as si
import matplotlib.pyplot as plt
import matplotlib


font = {'family' : 'serif',
		'serif'  : 'Times New Roman',
        'weight' : 'normal',
        'size'   : 18}
matplotlib.rc('font', **font)  # pass in the font dict as kwargs
# Plot Data
Xe=np.linspace(1,300,600)
fig, ax1 = plt.subplots(figsize=(18,8))

Free=si.loadmat('Corner_Full_hc=0.084.mat')
Y=Free.items()[0][1]
Y=np.real(Y)
lns3=ax1.plot(Xe, Y, '-',label='hc=0.084mm')

Free=si.loadmat('Corner_Full_hc=0.254.mat')
Y=Free.items()[0][1]
Y=np.real(Y)
lns4=ax1.plot(Xe, Y, '-',label='hc=0.254mm')

Free=si.loadmat('Corner_Full_hc=0.381.mat')
Y=Free.items()[0][1]
Y=np.real(Y)
lns5=ax1.plot(Xe, Y, '-',label='hc=0.381mm')

Con=si.loadmat('Corner_Full_hc=0.508.mat')
Y=Con.items()[0][1]
Y=np.real(Y)
lns6=ax1.plot(Xe, Y, '-',label='hc=0.508mm')

Con=si.loadmat('Corner_Full.mat')
Y=Con.items()[0][1]
Y=np.real(Y)
lns7=ax1.plot(Xe, Y, '-',label='hv=0.762mm')

#ax1.set_xlim([0,60])
ax1.set_xlabel('Frequency(Hz)')
# Make the y-axis label and tick labels match the line color.
ax1.set_ylabel('Loss factor)')
lns = lns3+lns4+lns5+lns6+lns7
labs = [l.get_label() for l in lns]
ax1.legend(lns, labs, loc=3,ncol=1,fontsize=16)	

plt.show()