function [Node,Ee]=ConstructModel(Lx,nelx,Ly,nely,Lz,nelz)
if nargin==4
    % Element Node Assignment
    nodenrs = reshape((1:(1+nelx)*(1+nely)),1+nely,1+nelx);
    nodenrs(nely+1,:)=[];nodenrs(:,nelx+1)=[];
    nodenrs=reshape(nodenrs,nelx*nely,1);
    Ee=repmat(nodenrs,1,4)+repmat([0 1 2+nely 1+nely],nelx*nely,1);
    Ee=[transpose(1:nelx*nely),Ee];
    % Element Node Text
    cod=repmat(',',nelx*nely,1);
    EeStr=[];
    for i=1:size(Ee,2)
        if i==1
            EeStr=[EeStr num2str(Ee(:,i))];
        else
            EeStr=[EeStr cod num2str(Ee(:,i))];
        end
    end
    % Node Coordinate Assignment
    x=Lx:-Lx/nelx:0;
    y=Ly:-Ly/nely:0;
    x=reshape(transpose(x'*ones(1,(nely+1))),(nelx+1)*(nely+1),1);
    y=repmat(y',(nelx+1),1);
    z=zeros((1+nelx)*(1+nely),1);
    Node=[transpose(1:(nelx+1)*(nely+1)),y,x,z];
    % Node Coordinate Text
    cod=repmat(',',(nelx+1)*(nely+1),1);
    NodeStr=[];
    for i=1:size(Node,2)
        if i==1
            NodeStr=[NodeStr num2str(Node(:,i))];
        else
            NodeStr=[NodeStr cod num2str(Node(:,i))];
        end
    end
    Ee(:,1)=[];Node(:,1)=[];
elseif nargin==6
    % Element Node Assignment
    nodenrs = reshape((1:(1+nelx)*(1+nely)*(1+nelz)),1+nely,1+nelz,1+nelx);
    nodenrs(nely+1,:,:)=[];nodenrs(:,nelz,:)=[];nodenrs(:,:,nelx+1)=[];
    nodenrs=reshape(nodenrs,nelx*nely*nelz,1);
    Ee=repmat(nodenrs,1,8)+repmat([0 2*(nely+1) 2*(nely+1)+1 1 -(nely+1) nely+1 2+nely 1-(nely+1)],nelx*nely*nelz,1);
    Ee=[transpose(1:nelx*nely*nelz),Ee];
    % Element Node Text
    cod=repmat(',',nelx*nely*nelz,1);
    EeStr=[];
    for i=1:size(Ee,2)
        if i==1
            EeStr=[EeStr num2str(Ee(:,i))];
        else
            EeStr=[EeStr cod num2str(Ee(:,i))];
        end
    end
    % Node Coordinate Assignment
    x=Lx:-Lx/nelx:0;
    y=Ly:-Ly/nely:0;
    z=Lz:-Lz/nelz:0;
    x=reshape(transpose(x'*ones(1,(nely+1)*(nelz+1))),(nelx+1)*(nely+1)*(nelz+1),1);
    y=repmat(y',(nelx+1)*(nelz+1),1);
    z=repmat(reshape(transpose(z'*ones(1,(nely+1))),(nely+1)*(nelz+1),1),nelx+1,1);
    Node=[transpose(1:(nelx+1)*(nely+1)*(nelz+1)),x,y,z];
    % Node Coordinate Text
    cod=repmat(',',(nelx+1)*(nely+1)*(nelz+1),1);
    NodeStr=[];
    for i=1:size(Node,2)
        if i==1
            NodeStr=[NodeStr num2str(Node(:,i))];
        else
            NodeStr=[NodeStr cod num2str(Node(:,i))];
        end
    end
    Ee(:,1)=[];Node(:,1)=[];
end

