function [K,M,VV,DD,dN,lossfactor,edofMat]=FESolve(Es1,G,Es3,p_1,p_2,p_3,Ee,xPhys,K_cal,M_cal,penal,nelx,nely,nelz)
%% Boundary
% CCCC- 4 edges clamped
% SSSS- 4 edges simply surport
% SFFF- 1 edge simply surport
%%
nDOF=5;NodeNum=8;Size_Matrix=nDOF*NodeNum;n=nelx*nely;
m=nDOF*(1+nelx)*(1+nely)*(1+nelz);F=zeros(m,1);
edofMat = kron(nDOF*Ee,ones(1,nDOF))+repmat(repmat((-1*nDOF+1):1:0,1,NodeNum),n,1);
iK = reshape(kron(edofMat,ones(Size_Matrix,1))',n*Size_Matrix^2,1);
jK = reshape(kron(edofMat,ones(1,Size_Matrix))',n*Size_Matrix^2,1);
% Assemble K&M
K=[];M=[];
for i=1:size(xPhys,1)
    Es1_val=Es1;G2_val=0.1+(G-0.1)*xPhys(i)^penal;Es3_val=0.1+(Es3-0.1)*xPhys(i)^penal;
    p1_val=p_1;p2_val=1e-3+(p_2-1e-3)*xPhys(i)^penal;p3_val=1e-3+(p_3-1e-3)*xPhys(i)^penal;
    Ke=K_cal(Es1_val,Es3_val,G2_val);
    Me=M_cal(p1_val,p2_val,p3_val);    
    K=vertcat(K,Ke(:));
    M=vertcat(M,Me(:));
end
K= sparse(iK,jK,K);
M= sparse(iK,jK,M);
[K,M,dN,DelRecord]=FEBoundary(K,M,nelx,nely,nelz,nDOF,'SSSS');
%% Model Analysis
[VV,DD]=eigs(real(K),M,10,0);
[DD,II]=sort(diag(DD));
VV=VV(:,II);
Freq=sqrt(real(DD))/2/pi;
lossfactor=zeros(10,1);
for i=1:10
    VVr=VV(:,i);
    lossfactor(i)=(VVr.'*imag(K)*VVr)/(VVr.'*real(K)*VVr);
end
end
