clear;
%% MATERIAL PROPERTIES
Es1=68.9e9;G2=0.896e6*(1+0.5i);Es3=68.9e9;p1=2740;p2=999;p3=2740;
%% PREPARE FINITE ELEMENT ANALYSIS
nelx=20;nely=20;nelz=1;
h1=0.762*10^-3;h2=0.254*10^-3;h3=(0.762)*10^-3;
Lx=0.3048;Ly=0.3480;Lz=h1+h2+h3;
[~,Ee]=ConstructModel(Lx,nelx,Ly,nely,Lz,nelz);
%% Build Element Matrix
load K&M.mat
K_cal=matlabFunction(K);
M_cal=matlabFunction(M);
%% Load X_optimal
load 1&2&3.mat
x=xd(:);
%x=ones(400,1);
nDOF=5;NodeNum=8;Size_Matrix=nDOF*NodeNum;n=nelx*nely;
m=nDOF*(1+nelx)*(1+nely)*(1+nelz);F=zeros(m,1);
edofMat = kron(nDOF*Ee,ones(1,nDOF))+repmat(repmat((-1*nDOF+1):1:0,1,NodeNum),n,1);
iK = reshape(kron(edofMat,ones(Size_Matrix,1))',n*Size_Matrix^2,1);
jK = reshape(kron(edofMat,ones(1,Size_Matrix))',n*Size_Matrix^2,1);
% Assemble K&M
K=[];M=[];
for i=1:size(x,1)
    Es1_val=Es1;G2_val=G2*x(i);Es3_val=0.1;%Es3*x(i);
    p1_val=p1;p2_val=p2*x(i);p3_val=1e-3;%p3*x(i);
    Ke=K_cal(Es1_val,Es3_val,G2_val);
    Me=M_cal(p1_val,p2_val,p3_val);    
    K=vertcat(K,Ke(:));
    M=vertcat(M,Me(:));
end
K= sparse(iK,jK,K);
M= sparse(iK,jK,M);
FNL=(NodeC2L([ceil(3*nelx/4+1),ceil(nely/4+1), 1],nelx,nely,nelz)-1)*nDOF+3;F(FNL)=-1;
[K,M,F,dN,DelRecord]=FEBoundary(K,M,F,nelx,nely,nelz,nDOF,'SSSS');
%% Model Analysis
[VV,DD]=eigs(real(K),M,10,0);
[DD,II]=sort(diag(DD));
VV=VV(:,II);
% for i=1:10
%     U=ReVU(DelRecord.',VV(:,i),nelx,nely,nelz,nDOF);
%     [MSX,MSY,MS]=ModeShape(nelx,nely,nelz,nDOF,3,U);
%     figure(i)
%     surf(MSX,MSY,MS);
% end
Freq=sqrt(real(DD))/2/pi;
lossfactor=zeros(10,1);
for i=1:10
    VVr=VV(:,i);
    lossfactor(i)=(VVr.'*imag(K)*VVr)/(VVr.'*real(K)*VVr);
end
interval=2;F_n=150*interval;F_x=zeros(F_n,1);F_y=zeros(F_n,1);F_lf=zeros(F_n,1);
h = waitbar(0,'Initializing waitbar...');
for i=1:F_n
    waitbar(i/F_n,h,strcat(num2str(ceil(i/F_n*100)),'%'));
    w=2*i/interval*pi();
    Ub=(K-w^2*M)\F;
    U=ReVU(DelRecord.',Ub,nelx,nely,nelz,nDOF);
    F_x(i)=i;F_y(i)=U(FNL);
end
close(h);