import numpy as np
import scipy.io as si
import matplotlib.pyplot as plt
import matplotlib


font = {'family' : 'serif',
		'serif'  : 'Times New Roman',
        'weight' : 'normal',
        'size'   : 18}
matplotlib.rc('font', **font)  # pass in the font dict as kwargs
fig, ax1 = plt.subplots(figsize=(18,8))
Xe=np.linspace(1,150,300)
# Plot Data
Base=si.loadmat('Base.mat')
Y=Base['F_y'][:,0]
Y=np.log(np.abs(Y))
lns1=ax1.plot(Y, '--',label='Bare Plate')

Base=si.loadmat('FullSwp_two.mat')
Y=Base['F_y'][:,0]
Y=np.log(np.abs(Y))
lns2=ax1.plot(Y, '--',label='Bare Plate')

Base=si.loadmat('FullSwp.mat')
Y=Base['F_y'][:,0]
Y=np.log(np.abs(Y))
lns3=ax1.plot(Y, '-',label='Fully Covered')

Base=si.loadmat('OptSwp.mat')
Y=Base['F_y'][:,0]
Y=np.log(np.abs(Y))
lns4=ax1.plot(Y, '-',label='Optimized Layout with 50% Material')

#ax1.set_xlim([0,45])
ax1.set_ylim([-15,0.0])
ax1.set_xlabel('Frequency(Hz)')
# Make the y-axis label and tick labels match the line color.
ax1.set_ylabel('Log(Displacement Frequency Response)')
lns = lns1+lns2+lns3+lns4
labs = [l.get_label() for l in lns]
ax1.legend(lns, labs, loc=4,ncol=3,fontsize=16)	

plt.show()