import numpy as np
import scipy.io as si
import matplotlib.pyplot as plt
import matplotlib


font = {'family' : 'serif',
		'serif'  : 'Times New Roman',
        'weight' : 'normal',
        'size'   : 18}
matplotlib.rc('font', **font)  # pass in the font dict as kwargs
fig, ax1 = plt.subplots(figsize=(18,8))
# Plot Data
Base=si.loadmat('1&2&3.mat')
Y=Base['Oh'][:,0]
lns1=ax1.plot(Y, 's-',label='1st Mode',markersize=10)

Base=si.loadmat('1&2&3.mat')
Y=Base['Oh'][:,1]
lns2=ax1.plot(Y, 's-',label='2nd Mode',markersize=10)

Base=si.loadmat('1&2&3.mat')
Y=Base['Oh'][:,2]
lns3=ax1.plot(Y, 's-',label='3rd Mode',markersize=10)

ax1.set_xlim([0,45])
#ax1.set_ylim([0.08,0.20])
ax1.set_xlabel('Iteration Number')
# Make the y-axis label and tick labels match the line color.
ax1.set_ylabel('Modal Damping ratio')
lns = lns1+lns2+lns3
labs = [l.get_label() for l in lns]
ax1.legend(lns, labs, loc=4,ncol=3,fontsize=16)	

plt.show()