from caeModules import *
import customKernel
from abaqusConstants import *
from Parameters import *

def Post_process(Xe,Ele_NUM,vf):
	y=sorted(Xe,reverse=True)
	vt=y[int(np.floor((vf-0.001)*Ele_NUM/(1-0.001)))]
	Exa=np.where(Xe>=vt)
	Shr=np.where(Xe<vt)
	Xe[Exa]=1.0;Xe[Shr]=0.0
	return Xe

def Result_Plot_SIMP(opdb,Xe,Instance_Name,FieldName):
	# Display final design
	frame=opdb.steps['Step-1'].frames[-1]
	MaterialDensity= frame.FieldOutput(name=FieldName, description='Element Materials Density',type=SCALAR)
	MyInstance=opdb.rootAssembly.instances[Instance_Name]
	elementLabels=range(1,len(MyInstance.elements)+1)
	elementValues=[[i]  for i in Xe]
	MaterialDensity.addData(position=WHOLE_ELEMENT, instance=MyInstance, labels=elementLabels, data=elementValues)
	opdb.save()
	opdb.close()

iter_num = sys.argv[-1]
print iter_num
# Loading Final Xe
f=open('Xe_'+iter_num+'.txt','r')
Xe=pickle.load(f)
f.close()
# Original Plot
opdb = session.openOdb(name= 'Design_Job'+iter_num+'.odb',readOnly=FALSE)
FieldName='MaterialDensity_Original'
Result_Plot_SIMP(opdb,Xe,Instance_Name,FieldName)
# Postprocess Plot
opdb = session.openOdb(name= 'Design_Job'+iter_num+'.odb',readOnly=FALSE)
Xe=Post_process(Xe,len(Xe),vf)
f=open('Xe_Final.txt','w')
pickle.dump(Xe,f)
f.close()
FieldName='MaterialDensity'
Result_Plot_SIMP(opdb,Xe,Instance_Name,FieldName)