import pickle
import numpy as np
import matplotlib.pyplot as plt

def Post_process(Xe,Ele_NUM,vf):
	y=sorted(Xe,reverse=True)
	vt=y[int(np.floor((vf-0.001)*Ele_NUM/(1-0.001)))]
	Exa=np.where(Xe>=vt)
	Shr=np.where(Xe<vt)
	Xe[Exa]=1.0;Xe[Shr]=0.001
	return Xe

# Loading Final Xe
f=open('Xe_60.txt','r')
Xe=pickle.load(f)
f.close()
#Xe=np.ones(3600)
Xe=Post_process(Xe,len(Xe),0.5)
Xe_Plt=Xe.reshape(60,60)
fig, ax = plt.subplots()
cax=ax.imshow(Xe_Plt,interpolation="None",cmap='Greys',vmin=0.0, vmax=1.0)
cbaxes = fig.add_axes([0.9, 0.1, 0.03, 0.8]) 
cb = plt.colorbar(cax, cbaxes)
ax.get_xaxis().set_visible(False)
ax.get_yaxis().set_visible(False)
plt.show()