function ViscoFE_7()
clear;
nelx=10;nely=12;nelz=0;
Lx=0.3048;Ly=0.3480;Lz=1;w=133*2*pi();KT=1e16;
[Nodes,Ee]=ConstructModel(Lx,nelx,Ly,nely);
%% Build Element Matrix
a=Lx/nelx;b=Ly/nely;
[Keb,Ked,Meb,Med]=Viscoelastic_damping_layer_FEmodel_Test(a/2,b/2);
% [Keb,Ked,Meb,Med]=Viscoelastic_damping_layer_FEmodel_7_backup(a/2,b/2);
K=Keb+Ked;M=Meb+Med;
%% FE-ANASIS
nDOF=7;NodeNum=4;Size_Matrix=nDOF*NodeNum;n=nelx*nely;
m=nDOF*(1+nelx)*(1+nely)*(1+nelz);F=zeros(m,1);
edofMat = kron(nDOF*Ee,ones(1,nDOF))+repmat(repmat((-1*nDOF+1):1:0,1,NodeNum),n,1);
iK = reshape(kron(edofMat,ones(Size_Matrix,1))',n*Size_Matrix^2,1);
jK = reshape(kron(edofMat,ones(1,Size_Matrix))',n*Size_Matrix^2,1);
EK=reshape(K(:)*ones(1,n),n*Size_Matrix^2,1);K= sparse(iK,jK,EK);
EM=reshape(M(:)*ones(1,n),n*Size_Matrix^2,1);M= sparse(iK,jK,EM);
%% Load and Boundary
F=FELoad(-1000,F,Ee,nelx,nely,nelz,'CF');
[K,M,F,BNodes,DelRecord]=FEBoundary(K,M,F,nelx,nely,0,nDOF,'SSSS');
% BoundaryElement={1:nely;nely:nely:nelx*nely;(nelx-1)*nely+1:nelx*nely;1:nely:(nelx-1)*nely+1};
% for i=1:4
%     for j=1:size(BoundaryElement{i},2)
%         CorElement=BoundaryElement{i};
%         Coor=edofMat(CorElement(j),:);
%         K(Coor,Coor)=K(Coor,Coor)+double(BoundaryGroup{i});
%     end
% end
%% Model Analysis
[VV,DD]=eigs(real(K),M,10,0);
lossfactor=zeros(10,1);eigenfrequency=lossfactor;
for i=1:10
    lossfactor(i)=transpose(VV(:,i))*imag(K)*VV(:,i)/(transpose(VV(:,i))*real(K)*VV(:,i));
end
for i=1:10
    eigenfrequency(i)=sqrt(DD(i,i))/2/pi();
end
S=-w^2*M+complex(0,1)*w*imag(K)+real(K);
U=S\F;U=ReVU(DelRecord,U,nelx,nely,nDOF);
MS=zeros(nelx+1,nely+1,7);
for i=1:7
MS(:,:,i)=ModeShape(nelx,nely,nelz,nDOF,i,U);
end
end
function MS=ModeShape(nelx,nely,nelz,nDOF,FD,U)
MS=zeros(nelx+1,nely+1);
MSX=MS;MSY=MS;
for i= 1:nelx+1
    for j = 1:nely+1
        n1=NodeC2L([i,j,1],nelx,nely,nelz);
        MS(i,j)=U((n1-1)*nDOF+FD);
        MSX(i,j)=i;
        MSY(i,j)=j;
    end
end
end

