function [K,M]=Viscoelastic_damping_layer_FEmodel_5(a,b)
disp('Part1:Seting...')
syms x y z
syms s n
a=a/2;b=b/2; % unit:m
h1=0.762*10^-3;h2=0.254*10^-3;h3=0.762*10^-3; % unit:m
h1=h1/2;h2=h2/2;h3=h3/2;
us=0.3;uv=0.49;
Es=68.9*10^9; % Unit:Pa
Gv=0.896*10^6*complex(1,0.5); % Complex Model,unit:pa
Gvr=real(Gv);Evr=Gvr*2*(1+uv);
Gvi=imag(Gv);
p1=2740;p2=999;p3=2740; % kg/m**3
% Building Qs Qv
Qs=Es/(1-us^2)*[1,us,0;us,1,0;0,0,(1-us)/2];
Qvr=Evr/(1+uv)/(1-2*uv)*[1-uv,uv,uv,0,0,0;uv,1-uv,uv,0,0,0;uv,uv,1-uv,0,0,0;0,0,0,0.5-uv,0,0;0,0,0,0,0.5-uv,0;0,0,0,0,0,0.5-uv];
Qvi=[0,0,0,0,0,0;0,0,0,0,0,0;0,0,0,0,0,0;0,0,0,Gvi,0,0;0,0,0,0,Gvi,0;0,0,0,0,0,Gvi];
Qv=Qvr+complex(0,1)*Qvi;
Hs=[1,0,0,-z,0;0,1,0,0,-z;0,0,1,0,0];
MAP_SN=[x/a,y/b;-x/a,y/b;-x/a,-y/b;x/a,-y/b];
H_G_SHAPE_FUNC=[1/4*(1+s)*(1+n),1/8*(1+s)*(1+n)*(2+s+n-(x/a)^2-(y/b)^2),1/8*s/(x/a)*(1+s)^2*(s-1)*(1+n)*a,1/8*n/(y/b)*(1+n)^2*(n-1)*(1+s)*b];

disp('Part2:Build Constrain Layer and Base Layer...');
disp('Build Ns')
N=[];
for i=1:4
    %Substitue s and n
    Stemp=[];
    for e=1:4
        Stemp=[Stemp,subs(H_G_SHAPE_FUNC(e),{s,n},{MAP_SN(i,1),MAP_SN(i,2)})];
    end
    NT=[Stemp(1),0,0,0,0;
        0,Stemp(1),0,0,0;
        0,0,Stemp(2),Stemp(3),Stemp(4);
        0,0,diff(Stemp(2),x),diff(Stemp(3),x),diff(Stemp(4),x);
        0,0,diff(Stemp(2),y),diff(Stemp(3),y),diff(Stemp(4),y)];
    N=[N,NT];
end
Ns=Hs*N;
disp('Build Bs');
Bs_Sign=[1,0,0;0,2,0;2,1,0];
col=size(Ns,2);row=size(Bs_Sign,1);r=size(Bs_Sign,2);
Bs=sym(zeros(row,col));
for i=1:row
    for j=1:col
        for k=1:r
            if Bs_Sign(i,k)==1
                Bs(i,j)=Bs(i,j)+diff(Ns(k,j),x);
            elseif Bs_Sign(i,k)==2
                Bs(i,j)=Bs(i,j)+diff(Ns(k,j),y);
            elseif Bs_Sign(i,k)==3
                Bs(i,j)=Bs(i,j)+diff(Ns(k,j),z);
            end
        end
    end
end
%K1--Base Plate K2--Viscoelastic Plate K3--Constraint Plate
disp('integrate K1');
K1=(int(int(int(transpose(Bs)*Qs*Bs,x,-a,a),y,-b,b),z,-h1,h1));
disp('integrate M1');
M1=p1*(int(int(int(transpose(Ns)*Ns,x,-a,a),y,-b,b),z,-h1,h1));
disp('integrate K3');
K3=(int(int(int(transpose(Bs)*Qs*Bs,x,-a,a),y,-b,b),z,-h3,h3));
disp('integrate M3');
M3=p3*(int(int(int(transpose(Ns)*Ns,x,-a,a),y,-b,b),z,-h3,h3));

disp('Part3:Build Viscoelastic Layer...');
%Building T
T=[0.5-1*z/h2,0,0,0.5+1*z/h2,0,0;
   0,0.5-1*z/h2,0,0,0.5+1*z/h2,0;
   0,0,0.5-1*z/h2,0,0,0.5+1*z/h2];

%Building Hv
cH=size(Hs,2);rH=size(Hs,1);
Hv=sym(zeros(2*rH,2*cH));
Hv(1:rH,1:cH)=subs(Hs,z,h1/2);
Hv(rH+1:2*rH,cH+1:2*cH)=subs(Hs,z,-h3/2);

%Building Nv
cN=size(N,2);rN=size(N,1);
Nv=sym(zeros(2*rN,2*cN));
Nv(1:rN,1:cN)=N;
Nv(rN+1:2*rN,cN+1:2*cN)=N;
Nv=T*Hv*Nv;

%Build Bv
Bv_Sign=[1,0,0;0,2,0;0,0,3;2,1,0;0,3,2;3,0,1];
col=size(Nv,2);row=size(Bv_Sign,1);r=size(Bv_Sign,2);
Bv=sym(zeros(row,col));
for i=1:row
    for j=1:col
        for k=1:r
            if Bv_Sign(i,k)==1
                Bv(i,j)=Bv(i,j)+diff(Nv(k,j),x);
            elseif Bv_Sign(i,k)==2
                Bv(i,j)=Bv(i,j)+diff(Nv(k,j),y);
            elseif Bv_Sign(i,k)==3
                Bv(i,j)=Bv(i,j)+diff(Nv(k,j),z);
            end
        end
    end
end
disp('integrate M2');
M2=p2*(int(int(int(transpose(Nv)*Nv,x,-a,a),y,-b,b),z,-h2,h2));
disp('integrate K2');
K2=(int(int(int(transpose(Bv)*Qv*Bv,x,-a,a),y,-b,b),z,-h2,h2));
disp('Building Gross Matrix');
K=K2;K(21:40,21:40)=K(21:40,21:40)+K3;K(1:20,1:20)=K(1:20,1:20)+K1;
M=M2;M(21:40,21:40)=M(21:40,21:40)+M3;M(1:20,1:20)=M(1:20,1:20)+M1;
K=double(K);M=double(M);
end
