function [Keb,Ked,Meb,Med]=Viscoelastic_damping_layer_FEmodel_7_backup(a,b)
disp('Part1:Parameters Seting...')
syms x y
syms s n
h1=0.762*10^-3;h2=0.254*10^-3;h3=0.762*10^-3; % unit:m
h0=h2+(h1+h3)/2;
us=0.3;uv=0.49;
Es=68.9*10^9; % Unit:Pa
Gv=0.896*10^6*complex(1,0.5); % Complex Model,unit:pa
Evr=Gv*2*(1+uv); % Unit:Pa
p1=2737;p2=999;p3=2737; % kg/m**3
disp('Part2:Elastic Matrix Seting...')
C1m=Es*h1/(1-us^2)*[1 us 0;us 1 0;0 0 (1-us)/2];
C2m=Evr*h2/(1-uv^2)*[1 uv 0;uv 1 0;0 0 (1-uv)/2];
C3m=Es*h3/(1-us^2)*[1 us 0;us 1 0;0 0 (1-us)/2];
C2s=Gv*h2*[1 0;0 1];
C1b=h1^2/12*C1m;C2b=h2^2/12*C2m;C3b=h3^2/12*C3m;
MAP_SN=[-x/a,-y/b;-x/a,y/b;x/a,y/b;x/a,-y/b];
H_G_SHAPE_FUNC=[1/4*(1+s)*(1+n),1/8*(1+s)*(1+n)*(2+s+n-s^2-n^2),1/8*s/(x/a)*(1+s)^2*(s-1)*(1+n)*a,1/8*n/(y/b)*(1+n)^2*(n-1)*(1+s)*b];
disp('Part3:All Freedom of Degrees Discretization and Shape Functions Generating...')
Ns=sym('Ns',[5,28]);
for i=1:4
    %Substitue s and n
    Stemp=[];
    for e=1:4
        Stemp=[Stemp,subs(H_G_SHAPE_FUNC(e),{s,n},{MAP_SN(i,1),MAP_SN(i,2)})];
    end
    NT=[        Stemp(2),        Stemp(3),        Stemp(4),0,0,0,0;
        0,               0,               0,Stemp(1),0,0,0;
        0,               0,               0,0,Stemp(1),0,0;
        0,               0,               0,0,0,Stemp(1),0;
        0,               0,               0,0,0,0,Stemp(1)];
    
    Ns(:,(i-1)*7+1:7*i)=NT;
end
Nw=Ns(1,:);Nu1=Ns(2,:);Nu3=Ns(3,:);Nv1=Ns(4,:);Nv3=Ns(5,:);
disp('Part4:Membrane/Bending/Shearing Strain Matrix for Layers Generating...')
N1m=[diff(Nu1,x);diff(Nv1,y);diff(Nu1,y)+diff(Nv1,x)];
N3m=[diff(Nu3,x);diff(Nv3,y);diff(Nu3,y)+diff(Nv3,x)];
N1b=[-diff(diff(Nw,x),x);-diff(diff(Nw,y),y);-2*diff(diff(Nw,x),y)];
N2m=(N1m+N3m)/2+(h3-h1)/4*N1b;
N2b=(N1m-N3m)/h2-(h3+h1)/(2*h2)*N1b;
N2s=1/h2*[Nu1-Nu3+h0*diff(Nw,x);Nv1-Nv3+h0*diff(Nw,y)];
N3b=N1b;Nalpha1=diff(Nw,x);Nalpha3=Nalpha1;
Nalpha2=(Nu1-Nu3)/h2+(h1+h3)/(2*h2)*diff(Nw,x);
Nbeta2=(Nv1-Nv3)/h2+(h1+h3)/(2*h2)*diff(Nw,y);
Nu2=(Nu1+Nu3)/2+(h1-h3)/4*diff(Nw,x);
Nv2=(Nv1+Nv3)/2+(h1-h3)/4*diff(Nw,y);
Nbeta1=diff(Nw,y);Nbeta3=Nbeta1;
disp('Part5:Gross K/M Matrix Generating ...')
Keb=transpose(N1m)*C1m*N1m+transpose(N1b)*C1b*N1b;
Ked=transpose(N2m)*C2m*N2m+transpose(N2s)*C2s*N2s+transpose(N3m)*C3m*N3m+transpose(N2b)*C2b*N2b+transpose(N3b)*C3b*N3b;
Keb=int(int(Keb,x,-a,a),y,-b,b);
Ked=int(int(Ked,x,-a,a),y,-b,b);
Meb=p1*h1*(transpose(Nu1)*Nu1+transpose(Nv1)*Nv1+transpose(Nw)*Nw)+h1^2/12*(transpose(Nalpha1)*Nalpha1+transpose(Nbeta1)*Nbeta1);
Med=p2*h2*(transpose(Nu2)*Nu2+transpose(Nv2)*Nv2+transpose(Nw)*Nw)+h2^2/12*(transpose(Nalpha2)*Nalpha2+transpose(Nbeta2)*Nbeta2)+...
    p3*h3*(transpose(Nu3)*Nu3+transpose(Nv3)*Nv3+transpose(Nw)*Nw)+h3^2/12*(transpose(Nalpha3)*Nalpha3+transpose(Nbeta3)*Nbeta3);
Meb=int(int(Meb,x,-a,a),y,-b,b);
Med=int(int(Med,x,-a,a),y,-b,b);
disp('Part6:Matrix Format Transfering...')
Keb=double(Keb);Ked=double(Ked);
Meb=double(Meb);Med=double(Med);
end