function [Keb,Ked,Meb,Med]=Viscoelastic_damping_layer_FEmodel_Test(a,b)
disp('Part1:Parameters Seting...')
syms s n si ni
GuassPoint1=[0,0];
GuassWeight1=[4];
GuassPoint=sqrt(3)/3*[-1,-1;1,-1;1,1;-1,1];
GuassWeight=[1;1;1;1];
%--------------------------------------------------------%
h1=0.762*10^-3;h2=0.254*10^-3;h3=0.762*10^-3; % unit:m
us=0.3;uv=0.49;
Es=68.9*10^9; % Unit:Pa
Gv=0.896*10^6*complex(1,0.5); % Complex Model,unit:pa
Evr=Gv*2*(1+uv); % Unit:Pa
p1=2737;p2=999;p3=2737; % kg/m**3
%--------------------------------------------------------%
h0=h2+(h1+h3)/2;
disp('Part2:Elastic Matrix Seting...')
C1m=Es*h1/(1-us^2)*[1 us 0;us 1 0;0 0 (1-us)/2];
C2m=Evr*h2/(1-uv^2)*[1 uv 0;uv 1 0;0 0 (1-uv)/2];
C3m=Es*h3/(1-us^2)*[1 us 0;us 1 0;0 0 (1-us)/2];
C2s=Gv*h2*[1 0;0 1];
C1b=h1^2/12*C1m;C2b=h2^2/12*C2m;C3b=h3^2/12*C3m;
MAP_SN=[-1,-1;-1,1;1,1;1,-1];
H_G_SHAPE_FUNC=[1/4*(1+s*si)*(1+n*ni),1/8*(1+s*si)*(1+n*ni)*(2+s*si+n*ni-s^2-n^2),1/8*si*(1+s*si)^2*(s*si-1)*(1+n*ni)*a,1/8*ni*(1+n*ni)^2*(n*ni-1)*(1+s*si)*b];
disp('Part3:All Freedom of Degrees Discretization and Shape Functions Generating...')
Ns=sym('Ns',[5,28]);
for i=1:4
    %Substitue s and n
    Stemp=[];
    for e=1:4
        Stemp=[Stemp,subs(H_G_SHAPE_FUNC(e),{si,ni},{MAP_SN(i,1),MAP_SN(i,2)})];
    end
    NT=[Stemp(2),   Stemp(3),        Stemp(4),0,0,0,0;
        0,               0,               0,Stemp(1),0,0,0;
        0,               0,               0,0,Stemp(1),0,0;
        0,               0,               0,0,0,Stemp(1),0;
        0,               0,               0,0,0,0,Stemp(1)];
    
    Ns(:,(i-1)*7+1:7*i)=NT;
end
Nw=Ns(1,:);Nu1=Ns(2,:);Nu3=Ns(3,:);Nv1=Ns(4,:);Nv3=Ns(5,:);
disp('Part4:Membrane/Bending/Shearing Strain Matrix for Layers Generating...')
N1m=[diff(Nu1,s)/a;diff(Nv1,n)/b;diff(Nu1,n)/b+diff(Nv1,s)/a];
N3m=[diff(Nu3,s)/a;diff(Nv3,n)/b;diff(Nu3,n)/b+diff(Nv3,s)/a];
N1b=[-diff(diff(Nw,s),s)/a^2;-diff(diff(Nw,n),n)/b^2;-2*diff(diff(Nw,s),n)/a/b];
N2m=(N1m+N3m)/2+(h3-h1)/4*N1b;
N2b=(N1m-N3m)/h2-(h3+h1)/(2*h2)*N1b;
N2s=1/h2*[Nu1-Nu3+h0*diff(Nw,s)/a;Nv1-Nv3+h0*diff(Nw,n)/b];
N3b=N1b;Nalpha1=diff(Nw,s)/a;Nalpha3=Nalpha1;
Nalpha2=(Nu1-Nu3)/h2+(h1+h3)/(2*h2)*diff(Nw,s)/a;
Nbeta2=(Nv1-Nv3)/h2+(h1+h3)/(2*h2)*diff(Nw,n)/b;
Nu2=(Nu1+Nu3)/2+(h1-h3)/4*diff(Nw,s)/a;
Nv2=(Nv1+Nv3)/2+(h1-h3)/4*diff(Nw,n)/b;
Nbeta1=diff(Nw,n)/b;Nbeta3=Nbeta1;
disp('Part5:Gross K/M Matrix Generating ...')
Keb=zeros(28,28);Ked=zeros(28,28);Meb=zeros(28,28);Med=zeros(28,28);
for i=1:4
    % Substitute GuassPoint for 's' and 'n'
    GroupOut=Subsyms({N1m,N2m,N3m,N1b,N2b,N3b,N2s,Nv1,Nv2,Nv3,Nu1,Nu2,Nu3,Nw,Nalpha1,Nalpha2,Nalpha3,Nbeta1,Nbeta2,Nbeta3},GuassPoint(i,1),GuassPoint(i,2));
    [N1mc,N2mc,N3mc,N1bc,N2bc,N3bc,N2sc,Nv1c,Nv2c,Nv3c,Nu1c,Nu2c,Nu3c,Nwc,Nalpha1c,Nalpha2c,Nalpha3c,Nbeta1c,Nbeta2c,Nbeta3c]=...
        deal(GroupOut{1},GroupOut{2},GroupOut{3},GroupOut{4},GroupOut{5},GroupOut{6},GroupOut{7},GroupOut{8},GroupOut{9},GroupOut{10},GroupOut{11},...
        GroupOut{12},GroupOut{13},GroupOut{14},GroupOut{15},GroupOut{16},GroupOut{17},GroupOut{18},GroupOut{19},GroupOut{20});
    % Calculate Gross K Matrix
    KTb=transpose(N1mc)*C1m*N1mc+transpose(N1bc)*C1b*N1bc;
    Keb=Keb+KTb*a*b*GuassWeight(i);
    KTd=transpose(N2mc)*C2m*N2mc+transpose(N3mc)*C3m*N3mc...
        +transpose(N2bc)*C2b*N2bc+transpose(N3bc)*C3b*N3bc...
;%         +transpose(N2sc)*C2s*N2sc;
    Ked=Ked+KTd*a*b*GuassWeight(i);
    % Calculate Gross M Matrix
    MTb=p1*h1*(transpose(Nu1c)*Nu1c+transpose(Nv1c)*Nv1c+transpose(Nwc)*Nwc+h1^2/12*(transpose(Nalpha1c)*Nalpha1c+transpose(Nbeta1c)*Nbeta1c));
    Meb=Meb+MTb*a*b*GuassWeight(i);
    MTd=p2*h2*(transpose(Nu2c)*Nu2c+transpose(Nv2c)*Nv2c+transpose(Nwc)*Nwc+h2^2/12*(transpose(Nalpha2c)*Nalpha2c+transpose(Nbeta2c)*Nbeta2c))...
        +p3*h3*(transpose(Nu3c)*Nu3c+transpose(Nv3c)*Nv3c+transpose(Nwc)*Nwc+h3^2/12*(transpose(Nalpha3c)*Nalpha3c+transpose(Nbeta3c)*Nbeta3c));
    Med=Med+MTd*a*b*GuassWeight(i);
end
% Shearing Part
for i=1:1
    GroupOut=Subsyms({N2s},GuassPoint1(i,1),GuassPoint1(i,2));
    N2sc=GroupOut{1};
    Ked=Ked+transpose(N2sc)*C2s*N2sc*a*b*GuassWeight1(i);
end
end
function GroupInp=Subsyms(GroupInp,P1,P2)
syms s n
for i=1:length(GroupInp)
    GroupInp{i}=double(subs(GroupInp{i},{s,n},{P1,P2}));
end
end
